package com.app.humfuel.activity

import android.content.Intent
import android.os.Bundle
import com.app.humfuel.R
import com.app.humfuel.fragment.login.LoginFragment
import com.app.humfuel.utils.Const
import com.app.humfuel.utils.setStatusBarTranslucent

class LoginSignupActivity : BaseActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_ls)

        if (store.getInt(Const.USER_ID) != 0) {
            val intnt = Intent(this, MainActivity::class.java)
            if (intent.getBooleanExtra("isPush", false)) {
                intnt.putExtra("isPush", intent.getBooleanExtra("isPush", false))
                intnt.putExtra("orderId", intent.getStringExtra("orderId"))
            }
            startActivity(intnt)
            finish()
        } else
            gotoLoginFragment()
        setStatusBarTranslucent(true, this)
    }

    private fun gotoLoginFragment() {
        supportFragmentManager
                .beginTransaction()
                .replace(R.id.frame_container_ls, LoginFragment())
                .commit()
    }

    override fun onBackPressed() {
        if (supportFragmentManager.findFragmentById(R.id.frame_container_ls) is LoginFragment) {
            exitFromApp()
        } else
            gotoLoginFragment()
    }
}
