package com.app.humfuel.fragment.home

import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.app.humfuel.R
import com.app.humfuel.adapter.OrdersAdapter
import com.app.humfuel.data.OrderData
import com.app.humfuel.fragment.BaseFragment
import kotlinx.android.synthetic.main.fg_home_ordelist.*
import java.util.*

/**
 * Created by neeraj on 4/8/17.
 */
class CompletedOrderFragment : BaseFragment() {

    private var orderDatas: ArrayList<OrderData>? = ArrayList()

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (arguments != null && arguments!!.containsKey("dataList")) {
            orderDatas = arguments!!.getParcelableArrayList("dataList")
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fg_home_ordelist, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        listRV.layoutManager = LinearLayoutManager(baseActivity)
        val ordersAdapter = OrdersAdapter(baseActivity, orderDatas!!)
        listRV.adapter = ordersAdapter
        ordersAdapter.registerAdapterDataObserver(object : RecyclerView.AdapterDataObserver() {
            override fun onChanged() {
                super.onChanged()
                emptyTV.visibility = if (ordersAdapter.itemCount == 0) View.VISIBLE else View.GONE
            }
        })
    }
}
