package com.app.humfuel.fragment.home

import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.app.humfuel.R
import com.app.humfuel.adapter.OrdersAdapter
import com.app.humfuel.data.OrderData
import com.app.humfuel.fragment.BaseFragment
import com.app.humfuel.retrofitManager.ResponseListener
import kotlinx.android.synthetic.main.fg_home_ordelist.*
import retrofit2.Call
import java.util.*

/**
 * Created by neeraj on 4/8/17.
 */
class PendingOrderFragment : BaseFragment() {

    private var orderDatas: ArrayList<OrderData> = ArrayList()
    private var cancelCall: Call<Any>? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (arguments != null && arguments!!.containsKey("dataList")) {
            orderDatas = arguments!!.getParcelableArrayList("dataList")!!
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fg_home_ordelist, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        listRV.layoutManager = LinearLayoutManager(baseActivity)
        val orders = ArrayList<OrderData>()
        orders.addAll(orderDatas)
        val ordersAdapter = OrdersAdapter(baseActivity, orders, this)
        listRV.adapter = ordersAdapter
        ordersAdapter.registerAdapterDataObserver(object : RecyclerView.AdapterDataObserver() {
            override fun onChanged() {
                super.onChanged()
                emptyTV.visibility = if (ordersAdapter.itemCount == 0) View.VISIBLE else View.GONE
            }
        })
    }

    fun cancelOrder(cancelReason: String, orderData1: OrderData) {
        cancelCall = apiInterface.orderCancel(orderData1.id.toString(), cancelReason)
        apiManager.makeApiCall(cancelCall, this)
    }

    override fun onSuccess(call: Call<*>, `object`: Any) {
        super.onSuccess(call, `object`)
        val fragment = baseActivity.supportFragmentManager.findFragmentById(R.id.frame_container)
        if (fragment is OrderListFragment) {
            fragment.getOrderList()
        }
    }

    override fun onError(call: Call<*>, statusCode: Int, errorMessage: String?, listener: ResponseListener) {
        super.onError(call, statusCode, errorMessage, listener)
        val fragment = baseActivity.supportFragmentManager.findFragmentById(R.id.frame_container)
        if (fragment is OrderListFragment) {
            fragment.getOrderList()
        }
    }
}
