package com.app.humfuel.fragment.home

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.app.humfuel.R
import com.app.humfuel.activity.MainActivity
import com.app.humfuel.data.ProfileData
import com.app.humfuel.data.UserData
import com.app.humfuel.fragment.BaseFragment
import com.app.humfuel.utils.Const
import kotlinx.android.synthetic.main.fg_profile.*
import retrofit2.Call

/**
 * Created by neeraj on 24/7/17.
 */
class ProfileFragment : BaseFragment() {

    private var isEdit: Boolean = false
    private var updateCall: Call<UserData>? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        setToolbar("Profile", true)
        return inflater.inflate(R.layout.fg_profile, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        doneBT.setOnClickListener {
            enableEdit(true)
            doneBT.text = "Submit"
            if (isEdit && validate()) {
                updateProfile()
            }
            isEdit = true
        }
        enableEdit(false)
        val userData = baseActivity.store.getUserData(Const.USER_DATA, UserData::class.java)
        if (userData != null) {
            nameET.setText(userData.name)
            emailET.setText(userData.email)
            phoneET.setText(userData.mobile)
        }
    }

    private fun validate(): Boolean {
        when {
            getText(nameET).isEmpty() -> showToast("Please enter name", true)
            getText(phoneET).isEmpty() -> showToast("Please enter phone number", true)
            getText(phoneET).length != 10 -> showToast("Phone number should be of 10 digit", true)
            else -> return true
        }
        return false
    }

    private fun updateProfile() {
        val profileData = ProfileData()
        profileData.userId = baseActivity.store.getInt(Const.USER_ID)
        profileData.name = getText(nameET)
        profileData.mobile = getText(phoneET)
        profileData.mobile = getText(phoneET)

        updateCall = apiInterface.updateProfile(profileData)
        apiManager.makeApiCall(updateCall, this)
    }

    private fun enableEdit(b: Boolean) {
        nameET.isEnabled = b
        nameET.isFocusableInTouchMode = b
        phoneET.isEnabled = b
        phoneET.isFocusableInTouchMode = b
    }

    override fun onSuccess(call: Call<*>, `object`: Any) {
        super.onSuccess(call, `object`)
        if (call === updateCall) {
            showToast("Profile updated successfully")
            val userData = `object` as UserData
            baseActivity.store.saveUserData(Const.USER_DATA, userData)
            baseActivity.store.saveString(Const.USER_NAME, userData.name)
            (baseActivity as MainActivity).setUserData()
            (baseActivity as MainActivity).gotoHome()
        }
    }
}
