package com.app.humfuel.fragment.login

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.app.humfuel.R
import com.app.humfuel.data.UserData
import com.app.humfuel.fragment.BaseFragment
import com.app.humfuel.utils.Const
import kotlinx.android.synthetic.main.fg_forgot_pass.*
import retrofit2.Call

/**
 * Created by neeraj on 14/6/17.
 */
class ForgotPasswordFragment : BaseFragment() {
    private var resetCall: Call<UserData>? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fg_forgot_pass, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        submitBT.setOnClickListener { if (validate()) gotoReset() }
        backIV.setOnClickListener(this)
    }

    private fun gotoReset() {
        resetCall = apiInterface.resetPassword(emailET.getText().toString().trim(), Const.LoginType.DEFAULT)
        apiManager.makeApiCall(resetCall, this)
    }

    private fun validate(): Boolean {
        if (getText(emailET).isEmpty()) {
            showToast("Please enter email", true)
        } else
            return true
        return false
    }

    override fun onSuccess(call: Call<*>, `object`: Any) {
        if (resetCall === call) {
            val userData = `object` as UserData
            val bundle = Bundle()
            userData.email = emailET.getText().toString().trim()
            bundle.putParcelable("data", userData)
            val fragment = NewPasswordFragment()
            fragment.arguments = bundle
            baseActivity.supportFragmentManager
                    .beginTransaction()
                    .replace(R.id.frame_container_ls, fragment)
                    .commit()
        }
    }
}
