package com.app.humfuel.fragment.login

import android.os.Bundle
import android.os.Handler
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.app.humfuel.R
import com.app.humfuel.data.UserData
import com.app.humfuel.fragment.BaseFragment
import com.app.humfuel.utils.Const
import kotlinx.android.synthetic.main.fg_new_password.*
import retrofit2.Call

/**
 * Created by neeraj on 14/6/17.
 */
class NewPasswordFragment : BaseFragment() {
    private var passCall: Call<UserData>? = null
    private var userData: UserData? = null
    private var attempt = 0

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (arguments != null && arguments!!.containsKey("data")) {
            userData = arguments!!.getParcelable("data")
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fg_new_password, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        submitBT.setOnClickListener { if (validate()) gotoSubmit() }
        backIV.setOnClickListener(this)
    }

    private fun gotoSubmit() {
        if (getText(otpET) != userData!!.oTP) {
            Handler().postDelayed({
                if (attempt < 4) {
                    if (attempt < 3)
                        showToast("OTP doesn't match")
                    else
                        showToast("Make sure you are entering correct OTP")
                    attempt++
                } else {
                    showToast("Too much attempts to enter OTP")
                    baseActivity.onBackPressed()
                }
            }, 2000)
        } else {
            passCall = apiInterface.newPassword(userData!!.email, getText(passwordET), Const.LoginType.DEFAULT)
            apiManager.makeApiCall(passCall, this)
        }
    }

    private fun validate(): Boolean {
        when {
            getText(otpET).isEmpty() -> showToast("Please enter OTP", true)
            getText(passwordET).isEmpty() -> showToast("Please enter New Password", true)
            else -> return true
        }
        return false
    }

    override fun onSuccess(call: Call<*>, `object`: Any) {
        if (passCall === call) {
            showToast("Password changed succesfully, Please login now")
            baseActivity.onBackPressed()
        }
    }
}
