package com.app.humfuel.fragment.login

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.app.humfuel.R
import com.app.humfuel.data.UserData
import com.app.humfuel.fragment.BaseFragment
import com.app.humfuel.fragment.OTPHandle
import com.app.humfuel.retrofitManager.ResponseListener
import com.app.humfuel.utils.Const
import kotlinx.android.synthetic.main.fg_verify_phone.*
import retrofit2.Call

/**
 * Created by neeraj on 14/6/17.
 */
class OTPFragment : BaseFragment() {
    private var otpCall: Call<UserData>? = null
    private var email: String? = null
    private var password: String? = null
    private var loginCall: Call<UserData>? = null
    private var isFromLogin: Boolean = false

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (arguments != null && arguments!!.containsKey("isFromLogin")) {
            email = arguments!!.getString("email")
            isFromLogin = arguments!!.getBoolean("isFromLogin")
        } else if (arguments != null && arguments!!.containsKey("email")) {
            email = arguments!!.getString("email")
            password = arguments!!.getString("password")
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fg_verify_phone, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        OTPHandle.readOTP(baseActivity, { otp -> submitOTP(otp) }, submitBT, verifyET1, verifyET2, verifyET3, verifyET4)
        backIV.setOnClickListener(this)
    }

    private fun submitOTP(otp: String) {
        otpCall = apiInterface.submitOTP(email, otp, Const.LoginType.DEFAULT)
        apiManager.makeApiCall(otpCall, this)
    }

    override fun onSuccess(call: Call<*>, `object`: Any) {
        if (otpCall === call) {
            if (isFromLogin) {
                showToast("OTP has been verified.Please login now")
                baseActivity.supportFragmentManager.popBackStack()
            } else doSilentLogin()
        } else if (loginCall === call) {
            val userData = `object` as UserData
            baseActivity.store.saveUserData(Const.USER_DATA, userData)
            baseActivity.store.setInt(Const.USER_ID, userData.userId)
            baseActivity.store.saveString(Const.USER_NAME, userData.name)
            gotoMainAct()
        }
    }

    override fun onError(call: Call<*>, statusCode: Int, errorMessage: String?, listener: ResponseListener) {
        if (call === loginCall) baseActivity.supportFragmentManager.popBackStack()
        else super.onError(call, statusCode, errorMessage, listener)
    }

    private fun doSilentLogin() {
        loginCall = apiInterface.login(email, password, Const.LoginType.DEFAULT, baseActivity.store.getString(Const.DEVICE_TOKEN))
        apiManager.makeApiCall(loginCall, this)
    }
}
