package com.app.humfuel.fragment.login

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.app.humfuel.R
import com.app.humfuel.data.SignupData
import com.app.humfuel.data.UserData
import com.app.humfuel.fragment.BaseFragment
import com.app.humfuel.utils.Const
import kotlinx.android.synthetic.main.fg_signup.*
import retrofit2.Call

/**
 * Created by neeraj on 14/6/17.
 */
class SignUpFragment : BaseFragment() {
    private var signupCall: Call<UserData>? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fg_signup, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        signupBT.setOnClickListener { if (validate()) doSignup() }
        backIV.setOnClickListener(this)
    }

    private fun doSignup() {
        val signupData = SignupData()
        signupData.name = getText(nameET)
        signupData.mobile = getText(phoneET)
        signupData.email = getText(emailET)
        signupData.password = getText(passwordET)
        signupData.loginType = Const.LoginType.DEFAULT

        signupCall = apiInterface.signup(signupData)
        apiManager.makeApiCall(signupCall, this)
    }

    private fun validate(): Boolean {
        when {
            getText(nameET).isEmpty() -> showToast("Please enter name", true)
            getText(phoneET).isEmpty() -> showToast("Please enter phone number", true)
            getText(phoneET).length != 10 -> showToast("Phone number should be of 10 digit")
            getText(emailET).isEmpty() -> showToast("Please enter email", true)
            !isValidMail(getText(emailET)) -> showToast("Please enter valid email", true)
            getText(passwordET).isEmpty() -> showToast("Please enter password", true)
            !isValidPassword(getText(passwordET)) -> showToast("Please enter valid password", true)
            else -> return true
        }
        return false
    }

    override fun onSuccess(call: Call<*>, `object`: Any) {
        if (signupCall === call) {
            val bundle = Bundle()
            bundle.putString("email", getText(emailET))
            bundle.putString("password", getText(passwordET))
            val fragment = OTPFragment()
            fragment.arguments = bundle
            baseActivity.supportFragmentManager
                    .beginTransaction()
                    .replace(R.id.frame_container_ls, fragment)
                    .commit()
        }
    }
}
