package com.app.humfuel.fragment.login

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.app.humfuel.R
import com.app.humfuel.data.SignupData
import com.app.humfuel.data.UserData
import com.app.humfuel.fragment.BaseFragment
import com.app.humfuel.utils.Const
import com.google.android.gms.auth.api.signin.GoogleSignIn
import com.google.android.gms.auth.api.signin.GoogleSignInOptions
import kotlinx.android.synthetic.main.fg_signup.*
import retrofit2.Call

/**
 * Created by neeraj on 14/6/17.
 */
class SocialLoginSignupFragment : BaseFragment() {
    private var signupCall: Call<UserData>? = null
    private var signupData: SignupData? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (arguments != null && arguments!!.containsKey("data")) {
            signupData = arguments!!.getParcelable("data")
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fg_signup, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        createTV.text = "Fill your details"
        signupBT.text = "Submit"
        signupBT.setOnClickListener { if (validate()) doSignup() }
        backIV.setOnClickListener(this)
        setPrefetchedData()
    }

    private fun setPrefetchedData() {
        nameET.isEnabled = signupData!!.name.trim { it <= ' ' }.isEmpty()
        nameET.setText(signupData!!.name)
        emailET.isEnabled = false
        passwordET.visibility = View.GONE
        emailET.setText(signupData!!.email)
    }


    private fun doSignup() {
        signupData!!.name = getText(nameET)
        signupData!!.mobile = getText(phoneET)
        signupData!!.email = getText(emailET)

        signupCall = apiInterface.signup(signupData)
        apiManager.makeApiCall(signupCall, this)
    }

    override fun onStop() {
        super.onStop()
        if (signupData!!.loginType == Const.LoginType.GOOGLE) {
            GoogleSignIn.getClient(baseActivity, GoogleSignInOptions.DEFAULT_SIGN_IN).signOut()
        }
    }

    private fun validate(): Boolean {
        when {
            getText(nameET).isEmpty() -> showToast("Please enter name", true)
            getText(phoneET).isEmpty() -> showToast("Please enter phone number", true)
            getText(phoneET).length != 10 -> showToast("Phone number should be of 10 digit")
            else -> return true
        }
        return false
    }

    override fun onSuccess(call: Call<*>, `object`: Any) {
        if (signupCall === call) {
            val userData = `object` as UserData
            baseActivity.store.setInt(Const.USER_ID, userData.userId)
            baseActivity.store.saveString(Const.USER_NAME, userData.name)
            gotoMainAct()
        }
    }
}
