package com.app.humfuel.retrofitManager;

import com.app.humfuel.data.OrderCreatingData;
import com.app.humfuel.data.OrderData;
import com.app.humfuel.data.OrderSubmitData;
import com.app.humfuel.data.PreorderData;
import com.app.humfuel.data.ProfileData;
import com.app.humfuel.data.SignupData;
import com.app.humfuel.data.TermsData;
import com.app.humfuel.data.UserData;

import java.util.ArrayList;

import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Query;

/**
 * Created by neeraj on 5/5/17.
 */
public interface ApiInterface {

    @POST("/api/fuel/RegisterUser")
    Call<UserData> signup(@Body SignupData signupData);

    @POST("/api/fuel/UpdateFuelUser")
    Call<UserData> updateProfile(@Body ProfileData profileData);

    @GET("/api/fuel/loginuser")
    Call<UserData> login(@Query("email") String email,
                         @Query("password") String password,
                         @Query("logintype") String loginType,
                         @Query("devicetoken") String deviceToken);

    @GET("/api/fuel/AuthenticateOTP")
    Call<UserData> submitOTP(@Query("email") String email,
                             @Query("OTP") String oTP,
                             @Query("loginType") String loginType);

    @GET("/api/fuel/AuthenticateUsername")
    Call<UserData> resetPassword(@Query("email") String email,
                                 @Query("loginType") String loginType);

    @GET("/api/fuel/ResetPassword")
    Call<UserData> newPassword(@Query("email") String email,
                               @Query("password") String password,
                               @Query("loginType") String loginType);

    @GET("/api/fuel/LogoutFuelUser")
    Call<Object> logoutUser(@Query("UserId") String userId);

    @GET("/api/fuel/getfuelordersettings")
    Call<PreorderData> preorderData(@Query("pincode") String pincode);

    @GET("/api/fuel/readtermsconditions")
    Call<TermsData> getTerms();

    @POST("/api/fuel/SubmitFuelOrder")
    Call<OrderSubmitData> submitOrder(@Body OrderCreatingData orderCreatingData);

    @POST("/api/fuel/UpdateFuelOrder")
    Call<OrderSubmitData> updateOrder(@Body OrderCreatingData orderCreatingData);

    @GET("/api/fuel/authenticateorderotp")
    Call<OrderSubmitData> authenticateOrder(@Query("orderid") String orderId,
                                            @Query("otp") String oTP);

    @GET("/api/fuel/ListFuelOrders")
    Call<ArrayList<OrderData>> ordersList(@Query("userid") String userId);

    @GET("/api/fuel/OrderCancelledByUser")
    Call<Object> orderCancel(@Query("orderId") String orderId, @Query("reason") String reason);

}
