package com.app.humfuel.utils

import android.app.Activity
import android.os.Build
import android.text.Editable
import android.text.TextWatcher
import android.view.WindowManager
import android.widget.EditText

fun setStatusBarTranslucent(makeTranslucent: Boolean, activity: Activity) {
    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
        activity.window.also {
            if (makeTranslucent) it.addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS)
            else it.clearFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS)
        }
    }
}

fun EditText.myTextWatcher(listener: (() -> Unit)): TextWatcher {
    val watcher = object : TextWatcher {
        override fun afterTextChanged(p0: Editable?) {
        }

        override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
        }

        override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
            listener.invoke()
        }
    }
    this.addTextChangedListener(watcher)
    return watcher
}