package com.vendor.humfuel.apiHandle;

import com.vendor.humfuel.data.OrderData;
import com.vendor.humfuel.data.ProfileData;
import com.vendor.humfuel.data.UserData;

import java.util.ArrayList;

import okhttp3.MultipartBody;
import retrofit2.Call;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.Multipart;
import retrofit2.http.POST;
import retrofit2.http.Part;
import retrofit2.http.Query;

/**
 * Created by neeraj on 5/5/17.
 */
public interface ApiInterface {

    @GET("/api/vendor/LoginVendorUser")
    Call<UserData> login(@Query("email") String email, @Query("password") String password, @Query("deviceToken") String token);

    @GET("/api/vendor/LogoutVendorUser")
    Call<Object> logoutUser(@Query("UserId") String userId);

    @POST("/api/vendor/UpdateVendorUser")
    Call<UserData> updateProfile(@Body ProfileData profileData);

    @GET("/api/vendor/ListVendorOrders")
    Call<ArrayList<OrderData>> getOrderList(@Query("vendorId") String vendorId);

    @GET("/api/vendor/OrderCancelledByVendor")
    Call<Object> orderCancel(@Query("orderId") String orderId, @Query("reason") String reason);

    @POST("/api/vendor/UpdateOrderStatusDispatched")
    Call<Object> orderDispatch(@Query("orderId") String orderId);

    @POST("/api/vendor/UpdateOrderStatusCompleted")
    @Multipart
    Call<Object> orderComplete(@Query("orderId") String orderId, @Part MultipartBody.Part imagePart);

}
