package com.vendor.humfuel.fragment

import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView

import com.vendor.humfuel.R
import com.vendor.humfuel.adapter.OrdersAdapter
import com.vendor.humfuel.data.OrderData
import kotlinx.android.synthetic.main.fg_home_ordelist.*

import java.util.ArrayList

/**
 * Created by neeraj on 4/8/17.
 */
class CompletedOrderFragment : BaseFragment() {

    private var orderDatas: ArrayList<OrderData>? = ArrayList()

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (arguments != null && arguments!!.containsKey("dataList")) {
            orderDatas = arguments!!.getParcelableArrayList("dataList")
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fg_home_ordelist, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        listRV.layoutManager = LinearLayoutManager(baseActivity)
        emptyTV.visibility = if (orderDatas!!.size == 0) View.VISIBLE else View.GONE
        if (orderDatas!!.size > 0) {
            val ordersAdapter = OrdersAdapter(baseActivity, orderDatas!!, this)
            listRV.adapter = ordersAdapter
        }
    }
}