package com.vendor.humfuel.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.vendor.humfuel.BuildConfig
import com.vendor.humfuel.R
import com.vendor.humfuel.data.UserData
import com.vendor.humfuel.utils.Const
import kotlinx.android.synthetic.main.fg_login.*
import retrofit2.Call

/**
 * Created by neeraj on 14/6/17.
 */
class LoginFragment : BaseFragment() {
    private var loginCall: Call<UserData>? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fg_login, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        loginBT.setOnClickListener(this)
        if (BuildConfig.DEBUG) {
            emailET.setText("neerajnarwal21@gmail.com")
            passwordET.setText("admin123")
        }
    }

    override fun onClick(v: View) {
        super.onClick(v)
        when (v.id) {
            R.id.loginBT -> if (validate()) {
                gotoLogin()
            }
        }
    }

    private fun gotoLogin() {
        loginCall = apiInterface.login(emailET.getText().toString().trim(), passwordET.getText().toString().trim(), baseActivity.store.getString(Const.DEVICE_TOKEN))
        apiHitAndHandle.makeApiCall(loginCall, this)
    }

    private fun validate(): Boolean {
        when {
            getText(emailET).isEmpty() -> showToast("Please enter email", true)
            getText(passwordET).isEmpty() -> showToast("Please enter password", true)
            else -> return true
        }
        return false
    }

    override fun onSuccess(call: Call<*>, `object`: Any) {
        if (loginCall === call) {
            val userData = `object` as UserData
            baseActivity.store.saveUserData(Const.USER_DATA, userData)
            baseActivity.store.setInt(Const.USER_ID, userData.userId)
            baseActivity.store.saveString(Const.USER_NAME, userData.name)
            gotoMainAct()
        }
    }
}
