package com.vendor.humfuel.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.EditText
import com.vendor.humfuel.R
import com.vendor.humfuel.activity.MainActivity
import com.vendor.humfuel.data.ProfileData
import com.vendor.humfuel.data.UserData
import com.vendor.humfuel.utils.Const
import kotlinx.android.synthetic.main.fg_profile.*
import retrofit2.Call

/**
 * Created by neeraj on 24/7/17.
 */
class ProfileFragment : BaseFragment() {

    private var isEdit: Boolean = false
    private var updateCall: Call<UserData>? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        setToolbar("Profile", true)
        return inflater.inflate(R.layout.fg_profile, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initUI()
    }

    private fun initUI() {
        doneBT.setOnClickListener {
            nameET.enableEdit(true)
            doneBT.text = "Submit"
            if (isEdit && validate()) {
                updateProfile()
            }
            isEdit = true
        }
        nameET.enableEdit(false)
        val userData = baseActivity.store.getUserData(Const.USER_DATA, UserData::class.java)
        if (userData != null) {
            nameET.setText(userData.name)
            emailET.setText(userData.email)
        }
    }

    private fun validate(): Boolean {
        if (getText(nameET).isEmpty()) {
            showToast("Please enter name", true)
        } else
            return true
        return false
    }

    private fun updateProfile() {
        val profileData = ProfileData()
        profileData.id = baseActivity.store.getInt(Const.USER_ID)
        profileData.name = getText(nameET)

        updateCall = apiInterface.updateProfile(profileData)
        apiHitAndHandle.makeApiCall(updateCall, this)
    }

    private fun EditText.enableEdit(b: Boolean) {
        this.apply {
            isEnabled = b
            isFocusableInTouchMode = b
        }
    }

    override fun onSuccess(call: Call<*>, `object`: Any) {
        super.onSuccess(call, `object`)
        if (call === updateCall) {
            showToast("Profile updated successfully")
            val userData = `object` as UserData
            baseActivity.store.saveUserData(Const.USER_DATA, userData)
            baseActivity.store.saveString(Const.USER_NAME, userData.name)
            (baseActivity as MainActivity).setUserData()
            (baseActivity as MainActivity).gotoHome()
        }
    }
}
